/*******************************************************************************
**
** header file for the 200-1017 Midi->CV board
**
*******************************************************************************/

#ifndef MIDI2001017__H
#define MIDI2001017__H

/*******************************************************************************
** Port Defines
**
*******************************************************************************/

#define DAC_LOW		(*((volatile char *)0x8800))	/*	low byte of dac	*/
#define DAC_HIGH	(*((volatile char *)0x8000))	/*	high byte of dac	*/
#define DAC_LOAD	(*((volatile char *)0x8400))	/*	transfer data
 								 	  				 from temp reg to dac	*/
/*	clear IRQ from S/H strobe done flag	*/
#define CLEAR_STROBE_IRQ	(*((volatile char *)0x8c00))	

/*******************************************************************************
** Defines for GATE PORT
*******************************************************************************/

#define GATE_WD		(*((volatile char *)0x8200))	/* write to GATE register */

#define GATE_GATE		0	  		/*		bit 0 outputs to gate	  */
#define GATE_CLOCK		1		/* Bit 1 is CLOCK	*/
#define GATE_STARTSTOP	2		/* Bit 2 is Start Stop Bits	*/
#define GATE_RESET		3		/* Bit 3 is RESET bit	*/
#define GATE_GATE1		4		/*	general gate bit	*/
#define GATE_GATE2		5		/*	general gate bit	*/
#define GATE_GATE3		6		/*	general gate bit	*/
#define GATE_GATE4		7		/*	general gate bit	*/	

/*******************************************************************************
** Defines for DAC outputs
*******************************************************************************/

#define DAC_PITCH		0
#define DAC_VELOCITY	1
#define DAC_WHEEL		2
#define DAC_CTL1		3		 

#endif	/*	MIDI200-1017__H	*/