//ICC-AVR application builder : 11/9/2003 9:13:45 AM
// Target : 8515
// Crystal: 8.0000Mhz

#include <io8515v.h>
#include <macros.h>
#include "2001017.h"

void port_init(void)
{
 PORTA = 0xFF;
 DDRA  = 0x00;
 PORTB = 0xFF;
 DDRB  = 0x07;	//lower three bits are outputs (address lines to S/H)
 PORTC = 0xFF;
 DDRC  = 0x00;
 PORTD = 0xFF;
 DDRD  = 0x00; 
}

//TIMER0 initialisation - prescale:1024
// desired value: 1000Hz
// actual value: 1116.071Hz (10.4%)
void timer0_init(void)
{
 TCCR0 = 0x00; //stop timer
 TCNT0 = 0xF9; //set count value
 TCCR0 = 0x05; //start timer
}

//#pragma interrupt_handler timer0_ovf_isr:8
//void timer0_ovf_isr(void)
//{
// TCNT0 = 0xF9; //reload counter value
//}

//TIMER1 initialisation - prescale:8
// desired value: 1000Hz
// actual value: 1000.000Hz (0.0%)
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0xFC; //setup
 TCNT1L = 0x18;
 OCR1AH = 0x03;
 OCR1AL = 0xE8;
 OCR1BH = 0xfd;
 OCR1BL = 0xE8;
 TCCR1A = 0x10;
 TCCR1B = 0x02; //start Timer
}

#pragma interrupt_handler timer1_ovf_isr:7
void timer1_ovf_isr(void)
{
 TCNT1H = 0xFC; //reload counter high value
 TCNT1L = 0x18; //reload counter low value
}

//UART0 initialisation
// desired baud rate: 31250
// actual: baud rate:31250 (0.0%)
void uart0_init(void)
{
 UCR  = 0x00; //disable while setting baud rate
 UBRR = 0x0F; //set baud rate
 UCR  = 0xB8; //enable
}

//#pragma interrupt_handler uart0_rx_isr:10
//void uart0_rx_isr(void)
//{
 //uart has received a character in UDR
//}

//#pragma interrupt_handler uart0_udre_isr:11
//void uart0_udre_isr(void)
//{
 //character transferred to shift register so UDR is now empty
//}

extern int DAC_Shad[8];	//this is where the DAC is output from
extern int CurrentDac;
#pragma interrupt_handler int0_isr:2
void int0_isr(void)
{
 //external interupt on INT0
 	union {
    	int v;
        char cv[2];
	}x;
    
    CLEAR_STROBE_IRQ = x.cv[1];	//reset interrupt
	++CurrentDac;
	if(CurrentDac >= 8) CurrentDac = 0;
  	x.v = DAC_Shad[CurrentDac];
    PORTB = CurrentDac & 0x7;	//set S/H address Lines
	DAC_LOW = x.cv[0];
    DAC_HIGH = x.cv[1];
    DAC_LOAD = x.cv[1];			//arm S/H strobe and wait for interrupt...
}

#pragma interrupt_handler int1_isr:3
void int1_isr(void)
{
 //external interupt on INT1
}

//call this routine to initialise all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
	CLI(); //disable all interrupts
	port_init();
// timer0_init();
	timer1_init();
// uart0_init();

// MCUCR = 0x8B;
	//INT0 rising edge
    //INT1 Falling edge
	MCUCR = (1 << SRE) | (1 << SRW) | (1 << ISC00) | (1 << ISC01);	
//	GIMSK = 0xC0;
	GIMSK = (1 << INT0);
 	TIMSK = (1 << TOIE1);
    
 SEI(); //re-enable interrupts
 //all peripherals are now initialised
}

