	.module midi.c
	.area vector(rom, abs)
	.org 20
	rjmp _iTxd
	.org 18
	rjmp _iRxd
	.org 14
	rjmp _iTimer
	.area eeprom(rom, con, rel)
_DefaultMidiChannel::
	.byte 8
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\midi.c
	.dbsym e DefaultMidiChannel _DefaultMidiChannel c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\midi.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\midi.c
	.dbfunc e InitUart _InitUart fV
;              i -> R20,R21
;           baud -> R16,R17
	.even
_InitUart::
	rcall push_gset1
	.dbline -1
	.dbline 58
; /*******************************************************************************
; 	Midi.c
; 
; 	These are the functions that provide the interface to the midi port
; 
; *******************************************************************************/
; 
; #include <io8515v.h>
; #include <macros.h>
; #include <eeprom.h>
; #include "2001017.h"
; #include "midi.h"
; #include "chip.h"
; 
; #pragma interrupt_handler iTxd:iv_UART_DRE 
; #pragma interrupt_handler iRxd:iv_UART_RX
; #pragma interrupt_handler iTimer:iv_TIMER0_OVF
; 
; char GateShadow;
; 
; enum {IDLE,NOTE0,NOTE1};		//midi parser states
; 
; //--------------------------------------------------------------------------
; // Timer STuff...
; //--------------------------------------------------------------------------
; 
; unsigned char Counter;
; unsigned char CRV;
; 
; //--------------------------------------------------------------------------
; // Serial Stuff
; //--------------------------------------------------------------------------
; 
; typedef struct {
; 	volatile int head;
; 	volatile int tail;
; 	volatile int nchar;
; 	volatile int size;
; }IODESC;
; 
; volatile IODESC txdesc;
; char txbuff[32];
; volatile IODESC rxdesc;
; char rxbuff[32];
; 
; int DAC_Shad[8];	//this is where the DAC is output from
; int CurrentDac;		//current DAC being accessed
; 
; #pragma data:eeprom
; 
; char DefaultMidiChannel = 8;
; 
; #pragma data:data
; 
; char DefMidiChan;
; 
; void InitUart(int baud)
; {
	.dbline 61
; 	int i;
; 
; 	UCR |= 0x18;	/*	enable uart rec and xmit	*/
	in R24,0xa
	ori R24,24
	out 0xa,R24
	.dbline 62
; 	UBRR = baud;
	out 0x9,R16
	.dbline 63
; 	txdesc.head = 0;	/*	initialize transmit descriptor	*/
	clr R2
	clr R3
	sts _txdesc+1,R3
	sts _txdesc,R2
	.dbline 64
; 	txdesc.tail = 0;
	sts _txdesc+2+1,R3
	sts _txdesc+2,R2
	.dbline 65
; 	txdesc.nchar = 0;
	sts _txdesc+4+1,R3
	sts _txdesc+4,R2
	.dbline 66
; 	txdesc.size = 32;
	ldi R24,32
	ldi R25,0
	sts _txdesc+6+1,R25
	sts _txdesc+6,R24
	.dbline 67
; 	rxdesc.head = 0;	/*	initialize receiever descriptor	*/
	sts _rxdesc+1,R3
	sts _rxdesc,R2
	.dbline 68
; 	rxdesc.tail = 0;
	sts _rxdesc+2+1,R3
	sts _rxdesc+2,R2
	.dbline 69
; 	rxdesc.size = 32;
	sts _rxdesc+6+1,R25
	sts _rxdesc+6,R24
	.dbline 70
; 	rxdesc.nchar = 0;
	sts _rxdesc+4+1,R3
	sts _rxdesc+4,R2
	.dbline 71
; 	for(i=0;i<32;++i)
	clr R20
	clr R21
L10:
	.dbline 72
	.dbline 73
	ldi R24,<_txbuff
	ldi R25,>_txbuff
	mov R30,R20
	mov R31,R21
	add R30,R24
	adc R31,R25
	ldi R24,111
	std z+0,R24
	.dbline 74
	ldi R24,<_rxbuff
	ldi R25,>_rxbuff
	mov R30,R20
	mov R31,R21
	add R30,R24
	adc R31,R25
	ldi R24,105
	std z+0,R24
	.dbline 75
L11:
	.dbline 71
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 71
	cpi R20,32
	ldi R30,0
	cpc R21,R30
	brlt L10
	.dbline -2
	.dbline 76
; 	{
; 		txbuff[i] = 'o';
; 		rxbuff[i] = 'i';
; 	}
; }
L3:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 I
	.dbsym r baud 16 I
	.dbend
	.dbfunc e Disable _Disable fV
	.even
_Disable::
	.dbline -1
	.dbline 79
; 
; void Disable(void)		/*	disable interrupts	*/
; {
	.dbline 80
; 	SREG &= ~0x80;
	bclr 7
	.dbline -2
	.dbline 81
; }
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Enable _Enable fV
	.even
_Enable::
	.dbline -1
	.dbline 84
; 
; void Enable(void)		/* enable interrupts	*/
; {
	.dbline 85
; 	SREG |= 0x80;		
	bset 7
	.dbline -2
	.dbline 86
; }
L15:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e EnableRxIRQ _EnableRxIRQ fV
	.even
_EnableRxIRQ::
	.dbline -1
	.dbline 89
; 
; void EnableRxIRQ(void)	
; {
	.dbline 93
; 	/**************************
; 	** Enable Receiver interrupts
; 	**************************/
; 	UCR |= 0x80;
	sbi 0xa,7
	.dbline -2
	.dbline 94
; }
L16:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisableRxIRQ _DisableRxIRQ fV
	.even
_DisableRxIRQ::
	.dbline -1
	.dbline 97
; 
; void DisableRxIRQ(void)
; {
	.dbline 101
; 	/**************************
; 	** Disable Receirver interrupts
; 	**************************/
; 	UCR &= ~0x80;
	cbi 0xa,7
	.dbline -2
	.dbline 102
; }
L17:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e EnableTxIRQ _EnableTxIRQ fV
	.even
_EnableTxIRQ::
	.dbline -1
	.dbline 105
; 
; void EnableTxIRQ(void)
; {
	.dbline 106
; 	UCR |= 0x20;	/*	enable transmit data register empty interrupt	*/
	sbi 0xa,5
	.dbline -2
	.dbline 107
; }
L18:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisableTxIRQ _DisableTxIRQ fV
	.even
_DisableTxIRQ::
	.dbline -1
	.dbline 110
; 
; void DisableTxIRQ(void)
; {
	.dbline 111
; 	UCR &= ~0x20;	/*	disable transmit data register empty interrupt	*/
	cbi 0xa,5
	.dbline -2
	.dbline 112
; }
L19:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e iRxd _iRxd fV
;              c -> R16
	.even
_iRxd::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R16
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 115
; 
; void iRxd(void)
; {
	.dbline 120
; 	/**************************
; 	** Interrupt handler for 
; 	** Receive Interrupts
; 	**************************/
; 	char c = UDR;	/*	read data from receive data reg	*/
	in R16,0xc
	.dbline 121
; 	if(rxdesc.nchar < rxdesc.size)	/*	is there space to put char?	*/
	lds R2,_rxdesc+6
	lds R3,_rxdesc+6+1
	lds R4,_rxdesc+4
	lds R5,_rxdesc+4+1
	cp R4,R2
	cpc R5,R3
	brge L21
	.dbline 122
; 	{
	.dbline 123
; 		rxbuff[rxdesc.head++] = c;	/*	put character into buffer	*/
	lds R2,_rxdesc
	lds R3,_rxdesc+1
	mov R24,R2
	mov R25,R3
	adiw R24,1
	sts _rxdesc+1,R25
	sts _rxdesc,R24
	ldi R24,<_rxbuff
	ldi R25,>_rxbuff
	mov R30,R2
	mov R31,R3
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 124
; 		if(rxdesc.head == rxdesc.size) rxdesc.head = 0;	/*	wrap head pointer	*/
	lds R2,_rxdesc+6
	lds R3,_rxdesc+6+1
	lds R4,_rxdesc
	lds R5,_rxdesc+1
	cp R4,R2
	cpc R5,R3
	brne L25
	.dbline 124
	clr R2
	clr R3
	sts _rxdesc+1,R3
	sts _rxdesc,R2
L25:
	.dbline 125
	lds R24,_rxdesc+4
	lds R25,_rxdesc+4+1
	adiw R24,1
	sts _rxdesc+4+1,R25
	sts _rxdesc+4,R24
	.dbline 126
L21:
	.dbline -2
	.dbline 127
; 		rxdesc.nchar++;	/*	increment character count	*/
; 	}	/*	otherwise, just drop character	*/
; }
L20:
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R16,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbsym r c 16 c
	.dbend
	.dbfunc e iTxd _iTxd fV
;              c -> R20
	.even
_iTxd::
	rcall push_lset
	rcall push_gset1
	.dbline -1
	.dbline 130
; 
; void iTxd(void)		/* interrupt handler for uart	*/
; {
	.dbline 133
; 	char c;
; 
; 	c = (char)txbuff[txdesc.tail++];		/*	get character from buffer	*/
	lds R2,_txdesc+2
	lds R3,_txdesc+2+1
	mov R24,R2
	mov R25,R3
	adiw R24,1
	sts _txdesc+2+1,R25
	sts _txdesc+2,R24
	ldi R24,<_txbuff
	ldi R25,>_txbuff
	mov R30,R2
	mov R31,R3
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	.dbline 134
; 	--txdesc.nchar;						/*	one less character to send	*/
	lds R24,_txdesc+4
	lds R25,_txdesc+4+1
	sbiw R24,1
	sts _txdesc+4+1,R25
	sts _txdesc+4,R24
	.dbline 135
; 	if(txdesc.nchar == 0)				/*	is xmit buffer empty?	*/				
	lds R2,_txdesc+4
	lds R3,_txdesc+4+1
	tst R2
	brne L32
	tst R3
	brne L32
X0:
	.dbline 136
; 		DisableTxIRQ();					/*	stop transmitting data	*/
	rcall _DisableTxIRQ
L32:
	.dbline 137
; 	if(txdesc.tail == txdesc.size) txdesc.tail = 0;	/* wrap tail pointer	*/
	lds R2,_txdesc+6
	lds R3,_txdesc+6+1
	lds R4,_txdesc+2
	lds R5,_txdesc+2+1
	cp R4,R2
	cpc R5,R3
	brne L35
	.dbline 137
	clr R2
	clr R3
	sts _txdesc+2+1,R3
	sts _txdesc+2,R2
L35:
	.dbline 138
; 	UDR = c;
	out 0xc,R20
	.dbline -2
	.dbline 139
; }
L29:
	rcall pop_gset1
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbsym r c 20 c
	.dbend
	.dbfunc e GetC _GetC fI
;              c -> R20,R21
	.even
_GetC::
	rcall push_gset1
	.dbline -1
	.dbline 142
; 
; int GetC(void)
; {
L41:
	.dbline 149
L42:
	.dbline 149
; 	/*********************************
; 	** Get a character from the UART
; 	** If there is no character, wait
; 	*********************************/
; 	int c;
; 
; 	while(rxdesc.nchar == 0);	/*	wait for character to apear in buffer	*/
	lds R2,_rxdesc+4
	lds R3,_rxdesc+4+1
	tst R2
	brne X1
	tst R3
	breq L41
X1:
	.dbline 150
; 	Disable();			/*	disable interrupts	*/
	rcall _Disable
	.dbline 151
; 	c = (int)rxbuff[rxdesc.tail++];		/*	get character from buffer	*/
	lds R2,_rxdesc+2
	lds R3,_rxdesc+2+1
	mov R24,R2
	mov R25,R3
	adiw R24,1
	sts _rxdesc+2+1,R25
	sts _rxdesc+2,R24
	ldi R24,<_rxbuff
	ldi R25,>_rxbuff
	mov R30,R2
	mov R31,R3
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	.dbline 152
; 	if(rxdesc.tail == rxdesc.size) rxdesc.tail = 0;	/*	wrap tail pointer	*/
	lds R2,_rxdesc+6
	lds R3,_rxdesc+6+1
	lds R4,_rxdesc+2
	lds R5,_rxdesc+2+1
	cp R4,R2
	cpc R5,R3
	brne L46
	.dbline 152
	clr R2
	clr R3
	sts _rxdesc+2+1,R3
	sts _rxdesc+2,R2
L46:
	.dbline 153
; 	rxdesc.nchar--;	/*	decrement number of chars in buffer	*/
	lds R24,_rxdesc+4
	lds R25,_rxdesc+4+1
	sbiw R24,1
	sts _rxdesc+4+1,R25
	sts _rxdesc+4,R24
	.dbline 154
; 	Enable();
	rcall _Enable
	.dbline 155
; 	return c;	/*	return fetched character	*/	
	mov R16,R20
	mov R17,R21
	.dbline -2
L40:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r c 20 I
	.dbend
	.dbfunc e PutC _PutC fV
;              i -> R20,R21
	.even
_PutC::
	rcall push_gset1
	mov R20,R16
	mov R21,R17
	.dbline -1
	.dbline 159
; }
; 
; void PutC(int i)
; {
L53:
	.dbline 160
L54:
	.dbline 160
; 	while(txdesc.nchar == txdesc.size);	/*	pend on buffer full	*/
	lds R2,_txdesc+6
	lds R3,_txdesc+6+1
	lds R4,_txdesc+4
	lds R5,_txdesc+4+1
	cp R4,R2
	cpc R5,R3
	breq L53
	.dbline 161
; 	Disable();	/*	Disable interrupts	*/
	rcall _Disable
	.dbline 162
; 	txbuff[txdesc.head++] = (char)i;	/*	put data into buffer	*/
	lds R2,_txdesc
	lds R3,_txdesc+1
	mov R24,R2
	mov R25,R3
	adiw R24,1
	sts _txdesc+1,R25
	sts _txdesc,R24
	ldi R24,<_txbuff
	ldi R25,>_txbuff
	mov R30,R2
	mov R31,R3
	add R30,R24
	adc R31,R25
	std z+0,R20
	.dbline 163
; 	if(txdesc.head == txdesc.size) txdesc.head = 0;	/*	wrap head pointer	*/
	lds R2,_txdesc+6
	lds R3,_txdesc+6+1
	lds R4,_txdesc
	lds R5,_txdesc+1
	cp R4,R2
	cpc R5,R3
	brne L58
	.dbline 163
	clr R2
	clr R3
	sts _txdesc+1,R3
	sts _txdesc,R2
L58:
	.dbline 164
; 	if(txdesc.nchar == 0)	/*	first char in buff?	*/
	lds R2,_txdesc+4
	lds R3,_txdesc+4+1
	tst R2
	brne L61
	tst R3
	brne L61
X2:
	.dbline 165
; 		EnableTxIRQ();		/*	start transmit interrupt	*/
	rcall _EnableTxIRQ
L61:
	.dbline 166
; 	txdesc.nchar++;
	lds R24,_txdesc+4
	lds R25,_txdesc+4+1
	adiw R24,1
	sts _txdesc+4+1,R25
	sts _txdesc+4,R24
	.dbline 167
; 	Enable();	/*	enable interrupts	*/	
	rcall _Enable
	.dbline -2
	.dbline 168
; }
L52:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 I
	.dbend
	.dbfunc e iTimer _iTimer fV
	.even
_iTimer::
	st -y,R2
	st -y,R24
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 171
	.dbline 175
	ldi R24,224
	out 0x32,R24
	.dbline 176
	lds R24,_Counter
	subi R24,1
	mov R2,R24
	sts _Counter,R2
	tst R24
	brne L66
	.dbline 177
	.dbline 181
	lds R2,_CRV
	sts _Counter,R2
	.dbline 182
L66:
	.dbline -2
	.dbline 183
; 
; void iTimer(void)
; {
; 	//-----------------------------------
; 	//timer interrupt handler
; 	//-----------------------------------
; 	TCNT0 = ~31;
; 	if(--Counter == 0)
; 	{
; //		GateShadow ^= 0x02;
; //		LED_PORT = ~GateShadow;
; //		GATE_PORT = GateShadow;
; 		Counter = CRV;
; 	}
; }
L65:
	ld R2,y+
	out 0x3f,R2
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e EnableTimerIrq _EnableTimerIrq fV
	.even
_EnableTimerIrq::
	.dbline -1
	.dbline 186
; 
; void EnableTimerIrq(void)
; {
	.dbline 187
; 	TIMSK |= 0x02;	//enable timer interrupt
	in R24,0x39
	ori R24,2
	out 0x39,R24
	.dbline -2
	.dbline 188
; }
L68:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisableTimerIrq _DisableTimerIrq fV
	.even
_DisableTimerIrq::
	.dbline -1
	.dbline 191
; 
; void DisableTimerIrq(void)
; {
	.dbline 192
; 	TIMSK &= ~0x02;	//disable timer interrupt
	in R24,0x39
	andi R24,253
	out 0x39,R24
	.dbline -2
	.dbline 193
; }
L69:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitTimer _InitTimer fV
	.even
_InitTimer::
	.dbline -1
	.dbline 196
; 
; void InitTimer(void)
; {
	.dbline 197
; 	TCCR0 = 5;	//system clock divided by 1024
	ldi R24,5
	out 0x33,R24
	.dbline 198
; 	TCNT0 = ~31;
	ldi R24,224
	out 0x32,R24
	.dbline 199
; 	Counter = 31;
	ldi R24,31
	sts _Counter,R24
	.dbline 200
; 	CRV = 31;
	sts _CRV,R24
	.dbline -2
	.dbline 201
; }
L70:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 205
; 
; 
; void Delay()
; {
	.dbline 208
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	rjmp L75
L72:
	.dbline 209
	ldi R18,1
	rjmp L79
L76:
	.dbline 209
L77:
	.dbline 209
	inc R18
L79:
	.dbline 209
	tst R18
	brne L76
L73:
	.dbline 208
	inc R16
L75:
	.dbline 208
	tst R16
	brne L72
	.dbline -2
	.dbline 210
; 		for (b = 1; b; b++);
; }
L71:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e main _main fI
	.area func_lit(rom, con, rel)
L112:
	.word `L90
	.word `L90
	.word `L90
	.word `L90
	.word `L90
	.word `L90
	.word `L90
	.word `L90
	.word `L104
	.word `L90
	.word `L106
	.word `L90
	.word `L108
	.word `L90
	.word `L90
	.word `L111
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\midi.c
;              t -> y+3
;    currentnote -> R14,R15
;       nextnote -> R20,R21
;           chan -> y+15
;          state -> y+14
;            cmd -> y+13
;              v -> y+11
;              c -> y+2
	.even
_main::
	sbiw R28,18
	.dbline -1
	.dbline 244
; 
; #define SYSEX			0xf0
; #define SYSCOMUNDEF		0xf1
; #define SYSCOMSONGPOS	0xf2
; #define SYSCOMSONGSEL	0xf3
; #define SYSCOMUNDEF1	0xf4
; #define SYSCOMUNDEF2	0xf5
; #define SYSCOMTUNEREQ	0xf6
; #define SYSEXEND		0xf7
; #define SYSRTCLOCK		0xf8
; #define SYSRTUNDEF		0xf9
; #define SYSRTSTART		0xfa
; #define SYSRTCONTINUE	0xfb
; #define SYSRTSTOP		0xfc
; #define SYSRTUNDEF1		0xfd
; #define SYSRTACTIVESEN	0xfe
; #define SYSRTRESET		0xff
; 
; #define NOTEON	0x90
; #define NOTEOFF	0x80
; #define NOTEPRES	0xa0		//note pressure
; #define CHANPRES	0xb0		//channel pressure
; #define CONTROL	0xd0			//control change
; #define WHEEL	0xe0			//pitch wheel change
; #define PATCH	0xc0			//patch change
; 
; 
; #define MIDI_CLOCK	0x80
; #define MIDI_START	0x40
; #define MIDI_RESET	0x20
; #define MIDI_GATE	0x01
; 
; main()
; {
	.dbline 256
; 	int currentnote,nextnote;
; 	volatile char c;
; 	char cmd;
; 	char chan;
; 	char state;
; 	int v;
; 	union {
;     	char hl[2];
;         int v;
;     }t;
;     
;     init_devices();
	rcall _init_devices
	.dbline 257
;    	InitTimer();	//initialize real clock timer
	rcall _InitTimer
	.dbline 258
; 	InitUart(BAUD_MIDI);
	ldi R16,15
	ldi R17,0
	rcall _InitUart
	.dbline 259
; 	EnableRxIRQ();	/*	enable receive interrupt	*/
	rcall _EnableRxIRQ
	.dbline 260
; 	EnableTimerIrq();
	rcall _EnableTimerIrq
	.dbline 261
; 	GateShadow = 0;
	clr R2
	sts _GateShadow,R2
	.dbline 262
; 	GATE_WD = GateShadow;	/*	set all outputs to zero	*/
	sts 33280,R2
	.dbline 263
;     EEPROM_READ((int)&DefaultMidiChannel,DefMidiChan);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_DefMidiChan
	ldi R19,>_DefMidiChan
	ldi R16,<_DefaultMidiChannel
	ldi R17,>_DefaultMidiChannel
	rcall _EEPROMReadBytes
	.dbline 264
; 	Enable();		/*	enable global interrupts	*/
	rcall _Enable
	.dbline 265
; 	for(v = 0;v < 8;++v)
	clr R0
	clr R1
	std y+12,R1
	std y+11,R0
L82:
	.dbline 266
	ldi R24,<_DAC_Shad
	ldi R25,>_DAC_Shad
	ldd R30,y+11
	ldd R31,y+12
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
L83:
	.dbline 265
	ldd R24,y+11
	ldd R25,y+12
	adiw R24,1
	std y+12,R25
	std y+11,R24
	.dbline 265
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brlt L82
	.dbline 267
;      DAC_Shad[v] = 0;
;     CLEAR_STROBE_IRQ = 0;
	clr R2
	sts 35840,R2
	.dbline 268
;     DAC_LOAD = 0;
	sts 33792,R2
	rjmp L87
L86:
	.dbline 270
; 	while(1)
; 	{
	.dbline 271
;  		c = GetC();
	rcall _GetC
	std y+2,R16
	.dbline 272
; 		if(c & 0x080)	//is it a command?
	mov R2,R16
	sbrs R16,7
	rjmp L89
	.dbline 273
; 		{
	.dbline 274
; 			if(c < 0x0f0)
	mov R24,R2
	cpi R16,240
	brsh L91
	.dbline 275
; 			{
	.dbline 277
; 				//process this stuff, dispose of everything else
; 				cmd = (char)(c & 0xf0);
	clr R25
	andi R24,240
	andi R25,0
	std y+13,R24
	.dbline 278
; 				chan = (char)(c & 0x0f);
	ldd R24,y+2
	clr R25
	andi R24,15
	andi R25,0
	std y+15,R24
	.dbline 280
; //				if(cmd == NOTEON)
; 					state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 281
; 			}
	rjmp L90
L91:
	.dbline 283
; 			else
; 			{
	.dbline 284
; 				switch(c)
	ldd R2,y+2
	clr R3
	std y+17,R3
	std y+16,R2
	mov R24,R2
	mov R25,R3
	cpi R24,240
	ldi R30,0
	cpc R25,R30
	brge X15
	rjmp L90
X15:
	ldi R24,255
	mov R0,R2
	mov R1,R3
	cp R24,R2
	cpc R25,R3
	brge X16
	rjmp L90
X16:
	ldi R24,<L112
	ldi R25,>L112
	mov R16,R2
	mov R17,R3
	subi R16,240
	sbci R17,0
	lsl R16
	rol R17
	add R16,R24
	adc R17,R25
	rcall lpm16
	mov R30,R16
	mov R31,R17
	ijmp
X3:
	.dbline 285
; 				{
	.dbline 287
; 					case SYSEX:
; 						break;
	.dbline 289
; 					case SYSCOMUNDEF:
; 						break;
	.dbline 291
; 					case SYSCOMSONGPOS:
; 						break;
	.dbline 293
; 					case SYSCOMSONGSEL:
; 						break;
	.dbline 295
; 					case SYSCOMUNDEF1:
; 						break;
	.dbline 297
; 					case SYSCOMUNDEF2:
; 						break;
	.dbline 299
; 					case SYSCOMTUNEREQ:
; 						break;
	.dbline 301
; 					case SYSEXEND:
; 						break;
L104:
	.dbline 303
; 					case SYSRTCLOCK:
; 						Disable();
	rcall _Disable
	.dbline 304
; 						GateShadow ^= (1 << GATE_CLOCK);	/*	toggle these bits	*/
	ldi R24,2
	lds R2,_GateShadow
	eor R2,R24
	sts _GateShadow,R2
	.dbline 305
; 						GATE_WD = GateShadow;
	sts 33280,R2
	.dbline 306
; 						Enable();
	rcall _Enable
	.dbline 307
; 						break;
	rjmp L90
X4:
	.dbline 309
; 					case SYSRTUNDEF:
; 						break;
L106:
	.dbline 311
; 					case SYSRTSTART:
; 						Disable();
	rcall _Disable
	.dbline 312
; 						GateShadow |= (1 << GATE_STARTSTOP);
	lds R24,_GateShadow
	ori R24,4
	sts _GateShadow,R24
	.dbline 313
; 						GateShadow &= ~(1 << GATE_RESET);
	andi R24,247
	sts _GateShadow,R24
	.dbline 314
; 						GATE_WD = GateShadow;
	mov R2,R24
	sts 33280,R2
	.dbline 315
; 						Enable();				
	rcall _Enable
	.dbline 316
; 						break;
	rjmp L90
X5:
	.dbline 318
; 					case SYSRTCONTINUE:
; 						break;
L108:
	.dbline 320
; 					case SYSRTSTOP:
; 						Disable();
	rcall _Disable
	.dbline 321
; 						GateShadow &= ~(1 << GATE_STARTSTOP);
	lds R24,_GateShadow
	andi R24,251
	sts _GateShadow,R24
	.dbline 322
; 						GATE_WD = GateShadow;
	mov R2,R24
	sts 33280,R2
	.dbline 323
; 						Enable();		
	rcall _Enable
	.dbline 324
; 						break;
	rjmp L90
X6:
	.dbline 326
; 					case SYSRTUNDEF1:
; 						break;
	.dbline 328
; 					case SYSRTACTIVESEN:
; 						break;
L111:
	.dbline 330
; 					case SYSRTRESET:
; 						Disable();
	rcall _Disable
	.dbline 331
; 						GateShadow &= ~(1 << GATE_STARTSTOP);
	lds R24,_GateShadow
	andi R24,251
	sts _GateShadow,R24
	.dbline 332
; 						GateShadow |= (1 << GATE_RESET);
	ori R24,8
	sts _GateShadow,R24
	.dbline 333
; 						GATE_WD = GateShadow;
	mov R2,R24
	sts 33280,R2
	.dbline 334
; 						Enable();		
	rcall _Enable
	.dbline 335
; 						break;
	.dbline 337
; 				}	//end of swtich(c)
; 			}	//end of if(c < 0xf0)
	.dbline 339
; 
; 		}
	rjmp L90
L89:
	.dbline 341
; 		else	// if(c & 0x080)	the it must be data
; 		{
	.dbline 345
; 			/*	we must handle the case of running status...so we need to keep track of
; 			**  which data byte we are on
; 			*/
; 			switch(cmd)	//what was the last command?
	ldd R10,y+13
	clr R11
	mov R24,R10
	mov R25,R11
	cpi R24,176
	ldi R30,0
	cpc R25,R30
	brne X17
	rjmp L114
X17:
	ldi R24,176
	cp R24,R10
	cpc R25,R11
	brlt L166
L165:
	mov R24,R10
	mov R25,R11
	cpi R24,144
	ldi R30,0
	cpc R25,R30
	brne X18
	rjmp L127
X18:
	ldi R24,144
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L168
L167:
	mov R24,R10
	mov R25,R11
	cpi R24,128
	ldi R30,0
	cpc R25,R30
	breq L116
	rjmp L113
L168:
	mov R24,R10
	mov R25,R11
	cpi R24,160
	ldi R30,0
	cpc R25,R30
	brne X19
	rjmp L144
X19:
	rjmp L113
L166:
	mov R24,R10
	mov R25,R11
	cpi R24,208
	ldi R30,0
	cpc R25,R30
	brne X20
	rjmp L151
X20:
	ldi R24,208
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L170
L169:
	mov R24,R10
	mov R25,R11
	cpi R24,192
	ldi R30,0
	cpc R25,R30
	brne X21
	rjmp L164
X21:
	rjmp L113
L170:
	mov R24,R10
	mov R25,R11
	cpi R24,224
	ldi R30,0
	cpc R25,R30
	brne X22
	rjmp L157
X22:
	rjmp L113
X7:
	.dbline 346
; 			{
L116:
	.dbline 348
; 				case NOTEOFF:	//last command was note off
; 					switch(state)
	ldd R22,y+14
	clr R23
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L120
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L121
	rjmp L114
X8:
	.dbline 349
; 					{
L120:
	.dbline 351
; 						case NOTE0:
; 							nextnote = ((int)c) << 9;
	ldi R18,9
	ldi R19,0
	ldd R16,y+2
	clr R17
	rcall lsl16
	mov R20,R16
	mov R21,R17
	.dbline 352
; 							state = NOTE1;
	ldi R24,2
	std y+14,R24
	.dbline 353
; 							break;
	rjmp L114
L121:
	.dbline 355
; 						case NOTE1:
; 							if(nextnote == currentnote)
	cp R20,R14
	cpc R21,R15
	brne L122
	.dbline 356
; 							{
	.dbline 357
; 	                           	if(DefMidiChan == chan)
	lds R2,_DefMidiChan
	ldd R0,y+15
	cp R2,R0
	brne L124
	.dbline 358
;                                 {
	.dbline 359
;  									Disable();
	rcall _Disable
	.dbline 360
; 									GateShadow &= ~MIDI_GATE;
	lds R24,_GateShadow
	andi R24,254
	sts _GateShadow,R24
	.dbline 361
;             	                    DAC_Shad[DAC_VELOCITY] = (int)c << 9;
	ldi R18,9
	ldi R19,0
	ldd R16,y+2
	clr R17
	rcall lsl16
	sts _DAC_Shad+2+1,R17
	sts _DAC_Shad+2,R16
	.dbline 362
; 									GATE_WD = GateShadow;
	lds R2,_GateShadow
	sts 33280,R2
	.dbline 363
; 									Enable();
	rcall _Enable
	.dbline 364
;                                 }
L124:
	.dbline 365
; 							}
L122:
	.dbline 366
; 							state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 367
; 							break;
	.dbline 369
; 					}
; 					break;
	rjmp L114
L127:
	.dbline 371
; 				case NOTEON:	// last command was note on
; 					switch(state)
	ldd R12,y+14
	clr R13
	mov R24,R12
	mov R25,R13
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L131
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L132
	rjmp L114
X9:
	.dbline 372
; 					{
L131:
	.dbline 374
; 						case NOTE0:
; 							nextnote = ((int)c) << 9;
	ldi R18,9
	ldi R19,0
	ldd R16,y+2
	clr R17
	rcall lsl16
	mov R20,R16
	mov R21,R17
	.dbline 375
; 							state = NOTE1;
	ldi R24,2
	std y+14,R24
	.dbline 376
; 							break;
	rjmp L114
L132:
	.dbline 378
; 						case NOTE1:
; 							Disable();
	rcall _Disable
	.dbline 379
; 							if(c > 0)
	clr R2
	ldd R3,y+2
	cp R2,R3
	brsh L133
	.dbline 380
; 							{
	.dbline 381
; 	                           	if(DefMidiChan == chan)
	lds R2,_DefMidiChan
	ldd R0,y+15
	cp R2,R0
	brne L134
	.dbline 382
;                                 {
	.dbline 383
; 									currentnote = nextnote;
	mov R14,R20
	mov R15,R21
	.dbline 384
; 									DAC_Shad[DAC_PITCH] = currentnote;
	sts _DAC_Shad+1,R15
	sts _DAC_Shad,R14
	.dbline 385
;         	                        DAC_Shad[DAC_VELOCITY] = c << 9;
	ldi R18,9
	ldi R19,0
	mov R16,R3
	clr R17
	rcall lsl16
	sts _DAC_Shad+2+1,R17
	sts _DAC_Shad+2,R16
	.dbline 386
;             	                    CurrentDac = DAC_PITCH;
	clr R2
	clr R3
	sts _CurrentDac+1,R3
	sts _CurrentDac,R2
	.dbline 387
; 									if(GateShadow & (1 << GATE_GATE))	//is gate already set?
	lds R2,_GateShadow
	sbrs R2,0
	rjmp L138
	.dbline 388
; 									{
	.dbline 389
; 										GateShadow &= ~(1 << GATE_GATE);	//retrigger gate
	mov R24,R2
	andi R24,254
	sts _GateShadow,R24
	.dbline 390
; 										GATE_WD = GateShadow;
	mov R2,R24
	sts 33280,R2
	.dbline 391
; 									}
L138:
	.dbline 392
; 									GateShadow |= (1 << GATE_GATE);
	lds R24,_GateShadow
	ori R24,1
	sts _GateShadow,R24
	.dbline 393
; 								}                                 
	.dbline 394
; 							}
	rjmp L134
L133:
	.dbline 396
; 							else
; 							{
	.dbline 397
; 								if(currentnote == nextnote)
	cp R14,R20
	cpc R15,R21
	brne L140
	.dbline 398
; 								{
	.dbline 399
; 	    	                       	if(DefMidiChan == chan)
	lds R2,_DefMidiChan
	ldd R0,y+15
	cp R2,R0
	brne L142
	.dbline 400
;     	                            {
	.dbline 401
; 										GateShadow &= ~(1 << GATE_GATE);
	lds R24,_GateShadow
	andi R24,254
	sts _GateShadow,R24
	.dbline 402
;                                     }
L142:
	.dbline 403
; 								}
L140:
	.dbline 404
; 							}
L134:
	.dbline 405
; 							GATE_WD = GateShadow;
	lds R2,_GateShadow
	sts 33280,R2
	.dbline 406
; 							Enable();
	rcall _Enable
	.dbline 407
; 							state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 408
; 							break;
	.dbline 410
; 						default:
; 							break;
	.dbline 412
; 					}
; 					break;
	rjmp L114
L144:
	.dbline 414
; 				case NOTEPRES:	// last command was note pressure
; 					switch(state)
	ldd R2,y+14
	clr R3
	std y+6,R3
	std y+5,R2
	mov R24,R2
	mov R25,R3
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L148
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L149
	rjmp L114
X10:
	.dbline 415
; 					{
L148:
	.dbline 417
; 						case NOTE0:
; 							state = NOTE1;
	ldi R24,2
	std y+14,R24
	.dbline 418
; 							break;
	rjmp L114
L149:
	.dbline 420
; 						case NOTE1:
; 							state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 421
; 							break;
	.dbline 423
; 					}
; 					break;
	rjmp L114
X11:
	.dbline 425
; 				case CHANPRES:		//last command was channel pressure
; 					break;
L151:
	.dbline 427
; 				case CONTROL:			//control change
; 					switch(state)
	ldd R2,y+14
	clr R3
	std y+8,R3
	std y+7,R2
	mov R24,R2
	mov R25,R3
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L155
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L156
	rjmp L114
X12:
	.dbline 428
; 					{
L155:
	.dbline 430
; 						case NOTE0:
; 							state = NOTE1;
	ldi R24,2
	std y+14,R24
	.dbline 431
; 							break;
	rjmp L114
L156:
	.dbline 433
; 						case NOTE1:
; 							state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 434
; 							break;
	.dbline 436
; 					}
; 					break;
	rjmp L114
L157:
	.dbline 438
; 				case WHEEL:			//last command was pitch wheel change
; 					switch(state)
	ldd R2,y+14
	clr R3
	std y+10,R3
	std y+9,R2
	mov R24,R2
	mov R25,R3
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L161
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L162
	rjmp L114
X13:
	.dbline 439
; 					{
L161:
	.dbline 441
; 						case NOTE0:
; 							v = ((int)c);
	ldd R2,y+2
	clr R3
	std y+12,R3
	std y+11,R2
	.dbline 442
; 							state = NOTE1;
	ldi R24,2
	std y+14,R24
	.dbline 443
; 							break;
	rjmp L114
L162:
	.dbline 445
; 						case NOTE1:
; 							v |= ((int)c)<<7;
	ldi R18,7
	ldi R19,0
	ldd R16,y+2
	clr R17
	rcall lsl16
	ldd R0,y+11
	ldd R1,y+12
	or R0,R16
	or R1,R17
	std y+12,R1
	std y+11,R0
	.dbline 446
; 							v <<= 2;	//12 bits;
	lsl R0
	rol R1
	std y+12,R1
	std y+11,R0
	lsl R0
	rol R1
	std y+12,R1
	std y+11,R0
	.dbline 447
;                             Disable();
	rcall _Disable
	.dbline 448
; 							DAC_Shad[DAC_WHEEL] = v;
	ldd R0,y+11
	ldd R1,y+12
	sts _DAC_Shad+4+1,R1
	sts _DAC_Shad+4,R0
	.dbline 449
;                             Enable();
	rcall _Enable
	.dbline 450
; 							state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 451
; 							break;
	.dbline 453
; 					}
; 					break;
	rjmp L114
L164:
	.dbline 455
; 				case PATCH:			//last command was patch change
; 					state = NOTE0;
	clr R0
	inc R0
	std y+14,R0
	.dbline 456
; 					break;
L113:
L114:
	.dbline 458
; 			}	//end of switch(cmd)
; 		}	//end of if(c & 0x080)
L90:
	.dbline 460
L87:
	.dbline 269
	rjmp L86
X14:
	.dbline 461
; 
; 	}	//end of while(1) loop
; 	return 0;
	clr R16
	clr R17
	.dbline -2
L80:
	adiw R28,18
	.dbline 0 ; func end
	ret
	.dbsym l t 3 X
	.dbsym r currentnote 14 I
	.dbsym r nextnote 20 I
	.dbsym l chan 15 c
	.dbsym l state 14 c
	.dbsym l cmd 13 c
	.dbsym l v 11 I
	.dbsym l c 2 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\midi.c
_DefMidiChan::
	.blkb 1
	.dbsym e DefMidiChan _DefMidiChan c
_CurrentDac::
	.blkb 2
	.dbsym e CurrentDac _CurrentDac I
_DAC_Shad::
	.blkb 16
	.dbsym e DAC_Shad _DAC_Shad A[16:8]I
_rxbuff::
	.blkb 32
	.dbsym e rxbuff _rxbuff A[32:32]c
_rxdesc::
	.blkb 8
	.dbsym e rxdesc _rxdesc X
_txbuff::
	.blkb 32
	.dbsym e txbuff _txbuff A[32:32]c
_txdesc::
	.blkb 8
	.dbsym e txdesc _txdesc X
_CRV::
	.blkb 1
	.dbsym e CRV _CRV c
_Counter::
	.blkb 1
	.dbsym e Counter _Counter c
_GateShadow::
	.blkb 1
	.dbsym e GateShadow _GateShadow c
