;*****************************************************************************************
;** These are the swap files for the AVR RTOS
;*****************************************************************************************

_Swap::
	push	r0	;first, push the context onto the stack
	push	r1
	push	r2
	push	r3
	push	r4
	push	r5
	push	r6
	push	r7
	push	r8
	push	r9
	push	r10
	push	r11
	push	r12
	push	r13
	push	r14
	push	r15
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	r23
	push	r24
	push	r25
	push	r26
	push	r27
	push	r28
	push	r29
	push	r30
	push	r31
	in		r0,SREG	;read in status reg
	push	r0		;push status reg onto stack
	in		r0,SPL	;read in stack pointer low
	in		r1,SPH	;read in stack pointer high
	;*********************************************************
	;_CurrentTask points to the task control block for the
	; current task
	;*********************************************************
	lds		r27,_CurrentTask+1	;load high byte of pointer
	lds		r26,_CurrentTask	;load low byte of pointer
	st		X+,r0	;store current stack pointer in task control block
	st		X+,r1
	;**********************************************************
	;_ReadyTask is a pointer to the tack control block of the
	; task that is ready to run
	;**********************************************************
	lds		r29,_ReadyTask+1	;load high byte of pointer
	lds		r28,_ReadyTask		;load low byte of pointer
	st		r29,-X				;Move Ready Task pointer to Current Task Pointer
	st		r28,-X
	ld		Y+,r0				;load low stack pointer
	out		SPL,r0
	ld		Y,r0				;load high stack pointer
	out		SPH,r0
	pop		r0					;pop status reg off of stack
	out		SREG,r0
	pop		r31					;pop working regsters to restore context
	pop		r30
	pop		r29
	pop		r28
	pop		r27
	pop		r26
	pop		r25
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17
	pop		r16
	pop		r15
	pop		r14
	pop		r13
	pop		r12
	pop		r11
	pop		r10
	pop		r9
	pop		r8
	pop		r7
	pop		r6
	pop		r5
	pop		r4
	pop		r3
	pop		r2
	pop		r1
	pop		r0
	reti					;this makes sure that interrupts are enabled
	;end of Swap

_IRQSwap:
	;*******************************************************
	;This is similar to Swap, but done at the interrupt level
	;
	; First, we need to clean up the stack
	;*******************************************************
	pop		r0
	pop		r0	;remove return address of call to _IRQSwap
	pop		r0
	pop		r0	;remove return address of ExitInterrupt
	;*********************************************************
	;_CurrentTask points to the task control block for the
	; current task
	;*********************************************************
	lds		r27,_CurrentTask+1	;load high byte of pointer
	lds		r26,_CurrentTask	;load low byte of pointer
	st		X+,r0	;store current stack pointer in task control block
	st		X+,r1
	;**********************************************************
	;_ReadyTask is a pointer to the tack control block of the
	; task that is ready to run
	;**********************************************************
	lds		r29,_ReadyTask+1	;load high byte of pointer
	lds		r28,_ReadyTask		;load low byte of pointer
	st		r29,-X				;Move Ready Task pointer to Current Task Pointer
	st		r28,-X
	ld		Y+,r0				;load low stack pointer
	out		SPL,r0
	ld		Y,r0				;load high stack pointer
	out		SPH,r0
	pop		r0					;pop status reg off of stack
	out		SREG,r0
	pop		r31					;pop working regsters to restore context
	pop		r30
	pop		r29
	pop		r28
	pop		r27
	pop		r26
	pop		r25
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17
	pop		r16
	pop		r15
	pop		r14
	pop		r13
	pop		r12
	pop		r11
	pop		r10
	pop		r9
	pop		r8
	pop		r7
	pop		r6
	pop		r5
	pop		r4
	pop		r3
	pop		r2
	pop		r1
	pop		r0
	reti					;this makes sure that interrupts are enabled
	;end of Swap

_ExitInterrupt:
	;**********************************************************
	;This routine needs to be called before an interrupt service
	;routine returns control.  Exit interrupt checks to see if
	;a swap needs to be done by checking the priority of any
	;tasks that are waiting in the priority queue
	;**********************************************************
